# Main program, only calls main.py

##########################################################################################################################
# Program structure:                                                                                                     #
# GUI tabs                                                                                                               #
# main.py: main windows, contains the plot tab and options. it also contains the set of statusBar hints and the menuBar  #
# tabdialog.py: this window manages the tabs, loads and save files, calls PPM and do some other fancy stuff              #
# the 4 tabs are coded in 4 different files:                                                                             #
# inptab.py: manages the layer input and some general fit and scan input                                                 #
# minfitab.py: manages the tab for the RvsPHI curve, with the relative fit                                               #
# minreftab.py: manages the tab for the RvsE curve, with the relative fit                                                #
# refltab.py: manage the reflEXAFS tab, with the calculation of the modified paths (to be implemented!)                  #
# logtxt.py: manage the log of the program, to be implemented!                                                           #
# layerdialog.py: manage the layer description, containing the structure parameters of every layer                       #
# non GUI tabs                                                                                                           #
# reader.py: utility to read the PPM .xml standard input, putting the input in a standard list output                    #
# writer.py: utility to write back a PPM .xml standard input, starting from a standard list input                        #
# rebin.py: from a reflectivity input gives a rebinned reflectivity, useful for the fit                                  #
# read the head of every file to know more                                                                               #
##########################################################################################################################

# IMPORTANT!!! for what the .xml input really does, you should read the PPM documentation


import sys
from PyQt4 import QtGui, QtCore
from main import MainWindow

if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    wd = MainWindow()
    wd.showMaximized()
    sys.exit(app.exec_())
