from numpy import *


class BackgroundRemoval:
    def __init__(self, in_file, col_1, col_2, col_3):
        data = data = loadtxt(in_file, unpack=True)
        self.E = data[col_1-1]
        if not col_2 == 0:
            self.R = data[col_3 - 1]/data[col_2 - 1]
        else:
            self.R = data[col_3 - 1]
    def Fit(self, grado):
        self.coeffs = polyfit(self.E,self.R,deg=grado)
    def ShowFit(self):
        self.yf = polyval(poly1d(self.coeffs), self.E)

class NewRef:
    def __init__(self, in_file, col_1, col_2, col_3):
        data = data = loadtxt(in_file, unpack=True)
        self.E = data[col_1-1]
        if not col_2 == 0:
            self.R = data[col_3 - 1]/data[col_2 - 1]
        else:
            self.R = data[col_3 - 1]
    def Remove(self, coeffs, energy = None, offset = None):
        if energy is not None:
            self.yf = polyval(poly1d(coeffs), energy)
            self.E_new = self.E- offset
        else:
            self.yf = polyval(poly1d(coeffs), self.E)
            self.E_new = self.E
        self.R_new = self.R/self.yf


if __name__ == '__main__':
    infile = 'TEST/vuoto_401.dat'
    rfile = 'TEST/4nio_101.dat'
    en = 1
    I0 = 2
    Ir = 3
    bg = BackgroundRemoval(infile, en, I0, Ir)
    bg.Fit(2)
    cfc = bg.coeffs
    newr = NewRef(rfile, en, I0, Ir)
    newr.Remove(cfc)
    savetxt('TEST/pippo', transpose((newr.E, newr.R, newr.R_new)), delimiter = ' ')
