import sys, os
from PyQt4 import QtGui, QtCore
from numpy import *
from string import atof

from background import *

class BackgroundDialog(QtGui.QDialog):
    def __init__(self, parent = None):
        super(BackgroundDialog,self).__init__(parent)
        self.setWindowTitle('Background Subctraction')
        self.home = os.getenv("HOME")
        self.inpGroup = QtGui.QGroupBox()
        self.bkg_label = QtGui.QLabel('bkg file: ')
        self.bkg = QtGui.QLineEdit()
        self.selBkgButton = QtGui.QPushButton('LOAD')
        self.connect(self.selBkgButton, QtCore.SIGNAL('clicked()'),self.selectBkgFile)
        self.pltBkgButton = QtGui.QPushButton('PLOT')
        self.connect(self.pltBkgButton, QtCore.SIGNAL('clicked()'),self.plotBkg)
        self.ref_label = QtGui.QLabel('refl file: ')
        self.ref = QtGui.QLineEdit()
        self.selRefButton = QtGui.QPushButton('LOAD')
        self.connect(self.selRefButton, QtCore.SIGNAL('clicked()'),self.selectRefFile)
        self.pltRefButton = QtGui.QPushButton('PLOT')
        self.connect(self.pltRefButton, QtCore.SIGNAL('clicked()'),self.plotRef)
        self.pol_l = QtGui.QLabel('Poly order: ')
        self.poly = QtGui.QSpinBox()
        self.poly.setValue(2)
        self.isphi = QtGui.QCheckBox('Is RvsPhi:')
        self.setEn_lab = QtGui.QLabel('Energy: ')
        self.setEn = QtGui.QLineEdit()
        self.offset_lab = QtGui.QLabel('Offset: ')
        self.offset = QtGui.QLineEdit('0.0')
        self.inpGroupLayout = QtGui.QGridLayout()
        self.inpGroupLayout.addWidget(self.bkg_label, 0,0)
        self.inpGroupLayout.addWidget(self.bkg, 0,1)
        self.inpGroupLayout.addWidget(self.selBkgButton, 0,2)
        self.inpGroupLayout.addWidget(self.pltBkgButton, 0,3)
        self.inpGroupLayout.addWidget(self.ref_label, 1,0)
        self.inpGroupLayout.addWidget(self.ref, 1,1)
        self.inpGroupLayout.addWidget(self.selRefButton, 1,2)
        self.inpGroupLayout.addWidget(self.pltRefButton, 1,3)
        self.inpGroupLayout.addWidget(self.pol_l, 2,0)
        self.inpGroupLayout.addWidget(self.poly, 2,1)
        self.inpGroupLayout.addWidget(self.setEn_lab, 2,2)
        self.inpGroupLayout.addWidget(self.offset_lab, 2,3)
        self.inpGroupLayout.addWidget(self.isphi, 3,1)
        self.inpGroupLayout.addWidget(self.setEn, 3,2)
        self.inpGroupLayout.addWidget(self.offset, 3,3)
        self.inpGroup.setLayout(self.inpGroupLayout)
        
        self.colGroup = QtGui.QGroupBox()
        self.bkg_col = QtGui.QLabel('bkg: ')
        self.ref_col = QtGui.QLabel('refl: ')
        self.E_l = QtGui.QLabel('E: ')
        self.I0_l = QtGui.QLabel('I0: ')
        self.Ir_l = QtGui.QLabel('Ir: ')
        self.bkg_E = QtGui.QSpinBox()
        self.bkg_E.setValue(1)
        self.bkg_I0 = QtGui.QSpinBox()
        self.bkg_I0.setValue(2)
        self.bkg_Ir = QtGui.QSpinBox()
        self.bkg_Ir.setValue(3)
        self.ref_E = QtGui.QSpinBox()
        self.ref_E.setValue(1)
        self.ref_I0 = QtGui.QSpinBox()
        self.ref_I0.setValue(2)
        self.ref_Ir = QtGui.QSpinBox()
        self.ref_Ir.setValue(3)
        self.colGroupLayout = QtGui.QGridLayout()
        self.colGroupLayout.addWidget(self.E_l, 0,1)
        self.colGroupLayout.addWidget(self.I0_l, 0,2)
        self.colGroupLayout.addWidget(self.Ir_l, 0,3)
        self.colGroupLayout.addWidget(self.bkg_col, 1,0)
        self.colGroupLayout.addWidget(self.bkg_E, 1,1)
        self.colGroupLayout.addWidget(self.bkg_I0, 1,2)
        self.colGroupLayout.addWidget(self.bkg_Ir, 1,3)
        self.colGroupLayout.addWidget(self.ref_col, 2,0)
        self.colGroupLayout.addWidget(self.ref_E, 2,1)
        self.colGroupLayout.addWidget(self.ref_I0, 2,2)
        self.colGroupLayout.addWidget(self.ref_Ir, 2,3)
        self.colGroup.setLayout(self.colGroupLayout)
        
        self.buttonGroup = QtGui.QGroupBox()
        self.fitButton = QtGui.QPushButton('FIT')
        self.connect(self.fitButton, QtCore.SIGNAL('clicked()'),self.fitBkg)
        self.subButton = QtGui.QPushButton('GO!')
        self.connect(self.subButton, QtCore.SIGNAL('clicked()'),self.fitRef)
        self.saveButton = QtGui.QPushButton('SAVE')
        self.connect(self.saveButton, QtCore.SIGNAL('clicked()'),self.savefile)
        self.buttonGroupLayout = QtGui.QHBoxLayout()
        self.buttonGroupLayout.addWidget(self.fitButton)
        self.buttonGroupLayout.addWidget(self.subButton)
        self.buttonGroupLayout.addWidget(self.saveButton)
        self.buttonGroup.setLayout(self.buttonGroupLayout)
        
        layout = QtGui.QVBoxLayout()
        layout.addWidget(self.inpGroup)
        layout.addWidget(self.colGroup)
        layout.addWidget(self.buttonGroup)
        self.setLayout(layout)
        
    def selectBkgFile(self):
        fileName = QtGui.QFileDialog.getOpenFileName(self,'select file', self.home,  'Ascii files ( *.txt *.dat ) ;;All files ( *.* )')
        if len(fileName) == 0:
            return
        fileName=str(fileName)
        self.bkg.setText(fileName)
    def selectRefFile(self):
        fileName = QtGui.QFileDialog.getOpenFileName(self,'select file', self.home,  'Ascii files ( *.txt *.dat ) ;;All files ( *.* )')
        if len(fileName) == 0:
            return
        fileName=str(fileName)
        self.ref.setText(fileName)
    def plotBkg(self):
        bg = BackgroundRemoval(str(self.bkg.text()), self.bkg_E.value(), self.bkg_I0.value(), self.bkg_Ir.value())
        msg = [bg.E,bg.R]
        self.emit(QtCore.SIGNAL('bkg_plot'),msg)
    def plotRef(self):
        newr = NewRef(str(self.ref.text()), self.ref_E.value(), self.ref_I0.value(), self.ref_Ir.value())
        msg = [newr.E,newr.R]
        self.emit(QtCore.SIGNAL('ref_plot'),msg)
    def fitBkg(self):
        bg = BackgroundRemoval(str(self.bkg.text()), self.bkg_E.value(), self.bkg_I0.value(), self.bkg_Ir.value())
        msg = [bg.E,bg.R]
        bg.Fit(self.poly.value())
        bg.ShowFit()
        msg.append(bg.yf)
        self.cfc = bg.coeffs
        self.emit(QtCore.SIGNAL('bkg_fit'),msg)
    def fitRef(self):
        newr = NewRef(str(self.ref.text()), self.ref_E.value(), self.ref_I0.value(), self.ref_Ir.value())
        if self.isphi.isChecked():
            newr.Remove(self.cfc,atof(str(self.setEn.text())),atof(str(self.offset.text())))
        else:
            newr.Remove(self.cfc)
        msg = [newr.E_new,newr.R_new]
        self.emit(QtCore.SIGNAL('ref_fit'),msg)
        self.E = newr.E_new
        self.R = newr.R_new
    def savefile(self):
        out = QtGui.QFileDialog.getSaveFileName(self,'select file', self.home,  'Ascii files ( *.txt *.dat ) ;;All files ( *.* )')
        if len(out) == 0:
            return
        out = str(out)
        savetxt(out, transpose((self.E, self.R)), delimiter = ' ')
        
if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    qb = BackgroundDialog()
    qb.show()
    sys.exit(app.exec_())

        
        
        
        
        
        
