
"""
reverse (f''->f') kk transform, using maclaurin series algorithm
  arguments:
    npts   size of arrays to consider
    e      energy array *must be on an even grid*  [npts]  (in)
    finp   f''    array                            [npts]  (in)
    fout   f'     array                            [npts]  (out)
 m newville  jan 1997
"""

fopi = 1.273239544735163
tiny = 1e-20

def kkmclr(e, finp):
    npts = len(e)
    fout = [0.0]*npts
    if npts >= 2:
        factor = -fopi * (e[npts-1] - e[0]) / (npts - 1)
        nptsk  = npts / 2
        for i in range(npts):
            fout[i] = 0.0
            ei2 = e[i]*e[i]
            ioff = i%2 - 1
            for k in range(nptsk):
                j = k + k + ioff
                de2 = e[j]*e[j] - ei2
                if abs(de2) <= tiny:
                    de2 = tiny
                fout[i] = fout[i] + e[j]*finp[j]/de2
            fout[i] *= factor
    return fout
