# create the dialog to add/modify a layer

import sys
from PyQt4 import QtGui, QtCore

import stechiometria

class InpDialog(QtGui.QDialog):
    def __init__(self, parent = None):
        super(InpDialog,self).__init__(parent)

        
        self.inpGroup = QtGui.QGroupBox(self.tr('Input'))
        self.setWindowIcon(QtGui.QIcon('icons/Layer.png'))
        self.inp_1 = QtGui.QLabel('Layer name')
        self.inp_1_edit = QtGui.QLineEdit()
        self.inp_2 = QtGui.QLabel('thickness (A)')
        self.inp_2_edit = QtGui.QLineEdit()
        self.inp_n = QtGui.QLabel('roughness (A)')
        self.inp_n_edit = QtGui.QLineEdit()
        self.inp_3 = QtGui.QLabel('density (g/cm3)')
        self.inp_3_edit = QtGui.QLineEdit()
        self.composition = QtGui.QLabel('composition')
        self.composition_edit = QtGui.QLineEdit()
        self.contButton = QtGui.QPushButton('CONTRIBUTION')
        self.connect(self.contButton, QtCore.SIGNAL('clicked()'), self.calcContribution)
        self.cont_edit = QtGui.QLabel()
        self.inpGroupLayout = QtGui.QGridLayout()
        self.inpGroupLayout.addWidget(self.inp_1, 0,0)
        self.inpGroupLayout.addWidget(self.inp_1_edit, 0,1)
        self.inpGroupLayout.addWidget(self.inp_2, 1,0)
        self.inpGroupLayout.addWidget(self.inp_2_edit, 1,1)
        self.inpGroupLayout.addWidget(self.inp_n, 2,0)
        self.inpGroupLayout.addWidget(self.inp_n_edit, 2,1)
        self.inpGroupLayout.addWidget(self.inp_3, 3,0)
        self.inpGroupLayout.addWidget(self.inp_3_edit, 3,1)
        self.inpGroupLayout.addWidget(self.composition, 4,0)
        self.inpGroupLayout.addWidget(self.composition_edit, 4,1)
        self.inpGroupLayout.addWidget(self.contButton, 5,0)
        self.inpGroupLayout.addWidget(self.cont_edit, 5,1)
        self.inpGroup.setLayout(self.inpGroupLayout)

        self.buttonGroup = QtGui.QGroupBox()
        self.buttonBox = QtGui.QDialogButtonBox(QtGui.QDialogButtonBox.Ok | QtGui.QDialogButtonBox.Cancel)
        self.connect(self.buttonBox, QtCore.SIGNAL('accepted()'), self, QtCore.SLOT('accept()'))
        self.connect(self.buttonBox, QtCore.SIGNAL('rejected()'), self, QtCore.SLOT('reject()'))
        self.buttonGroupLayout = QtGui.QVBoxLayout()
        self.buttonGroupLayout.addWidget(self.buttonBox)
        self.buttonGroup.setLayout(self.buttonGroupLayout)
        
        layout = QtGui.QVBoxLayout()
        layout.addWidget(self.inpGroup)
        layout.addWidget(self.buttonGroup)
        self.setLayout(layout)
        self.setWindowTitle('Layer Edit')
        
    def calcContribution(self):
        self.cont_edit.setText(stechiometria.from_st(str(self.composition_edit.text())))

if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    qb = InpDialog()
    qb.show()
    sys.exit(app.exec_())
