import sys, os
from PyQt4 import QtGui, QtCore
import varinpdialog
from string import atoi

class Minref(QtGui.QWidget):
    def __init__(self, parent = None):
        QtGui.QWidget.__init__(self, parent)
        self.setWindowTitle('minen tab')
        self.home = os.getenv("HOME")
        self.mini = ['scan']
        self.fileGroup = QtGui.QGroupBox()
        self.fileLabel = QtGui.QLabel('In File')
        self.fileSelect = QtGui.QLineEdit()
        self.fiLabel = QtGui.QLabel('Angle')
        self.fiSelect = QtGui.QLineEdit()
        self.loadRButton = QtGui.QPushButton('LOAD')
        self.connect(self.loadRButton, QtCore.SIGNAL('clicked()'),self.selectFile)

        self.plotRButton = QtGui.QPushButton('PLOT')
        self.outFile = QtGui.QLabel('Out File')
        self.outSelect = QtGui.QLineEdit()
        self.outButton = QtGui.QPushButton('SELECT')
        self.connect(self.outButton, QtCore.SIGNAL('clicked()'),self.saveFile)
        self.Ecol = QtGui.QLabel('ECol')
        self.ESelect = QtGui.QSpinBox()
        self.ESelect.setValue(1)
        self.rcol = QtGui.QLabel('RCol')
        self.RSelect = QtGui.QSpinBox()
        self.RSelect.setValue(2)
        self.rebinCheck = QtGui.QCheckBox('Weight E')
        self.fromenergy = QtGui.QLineEdit('min')
        self.toenergy_lab = QtGui.QLabel('to')
        self.toenergy = QtGui.QLineEdit('max')
        self.eweight_lab = QtGui.QLabel('Weight (0<W<1)')
        self.eweight = QtGui.QLineEdit('1.0')
        self.dele_lab = QtGui.QLabel('delE0 (eV)')
        self.dele = QtGui.QLineEdit('0.0')
        self.saveInp = QtGui.QPushButton('SAVE .xml')
        self.fileGroupLayout = QtGui.QGridLayout()
        self.fileGroupLayout.addWidget(self.fileLabel, 0,0)
        self.fileGroupLayout.addWidget(self.fileSelect, 0,1)
        self.fileGroupLayout.addWidget(self.loadRButton, 0,2)
        self.fileGroupLayout.addWidget(self.Ecol, 0,3)
        self.fileGroupLayout.addWidget(self.ESelect, 0,4)
        self.fileGroupLayout.addWidget(self.outFile, 1,0)
        self.fileGroupLayout.addWidget(self.outSelect, 1,1)
        self.fileGroupLayout.addWidget(self.outButton, 1,2)
        self.fileGroupLayout.addWidget(self.rcol, 1,3)
        self.fileGroupLayout.addWidget(self.RSelect, 1,4)
        self.fileGroupLayout.addWidget(self.fiLabel, 2,0)
        self.fileGroupLayout.addWidget(self.fiSelect, 2,1)
        self.fileGroupLayout.addWidget(self.plotRButton, 2,2)
        self.fileGroupLayout.addWidget(self.rebinCheck, 3,0)
        self.fileGroupLayout.addWidget(self.fromenergy, 4,0)
        self.fileGroupLayout.addWidget(self.toenergy_lab, 4,1)
        self.fileGroupLayout.addWidget(self.toenergy, 4,2)
        self.fileGroupLayout.addWidget(self.eweight_lab, 4,3)
        self.fileGroupLayout.addWidget(self.eweight, 4,4)
        self.fileGroupLayout.addWidget(self.dele_lab, 3,2)
        self.fileGroupLayout.addWidget(self.dele, 3,3)
        self.fileGroupLayout.addWidget(self.saveInp, 3,4)
        self.fileGroup.setLayout(self.fileGroupLayout)

        self.optGroup = QtGui.QGroupBox('Optimization')
        self.table = QtGui.QTableWidget()
        self.buttonBox = QtGui.QGroupBox()
        self.optBox = QtGui.QGroupBox()
        self.infoButton = QtGui.QPushButton('?')
        self.addButton = QtGui.QPushButton('Add')
        self.modButton = QtGui.QPushButton('Sel')
        self.delButton = QtGui.QPushButton('Del')
        self.optButton = QtGui.QPushButton('FIT')
        self.expButton = QtGui.QPushButton('EXPORT')
        self.undoButton = QtGui.QPushButton('RESTORE')
        self.opt1GroupLayout = QtGui.QVBoxLayout()
        self.opt1GroupLayout.addWidget(self.table)
        self.opt2GroupLayout = QtGui.QVBoxLayout()
        
        self.opt2GroupLayout.addWidget(self.infoButton)
        self.opt2GroupLayout.addWidget(self.addButton)
        self.opt2GroupLayout.addWidget(self.modButton)
        self.opt2GroupLayout.addWidget(self.delButton)
        self.opt2GroupLayout.addWidget(self.optButton)
        self.opt2GroupLayout.addWidget(self.expButton)
        self.opt2GroupLayout.addWidget(self.undoButton)
        
        self.buttonBox.setLayout(self.opt2GroupLayout)
        self.optBox.setLayout(self.opt1GroupLayout)
        
        
        self.optGroupLayout = QtGui.QHBoxLayout()
        self.optGroupLayout.addWidget(self.optBox)
        self.optGroupLayout.addWidget(self.buttonBox)
        self.optGroup.setLayout(self.optGroupLayout)

        
        layout = QtGui.QVBoxLayout()
        layout.addWidget(self.fileGroup)
        layout.addWidget(self.optGroup)
        self.setLayout(layout)
        self.updateTable()
        self.connect(self.delButton, QtCore.SIGNAL('clicked()'), self.delRow)
        self.connect(self.addButton, QtCore.SIGNAL('clicked()'), self.addDialog)
        self.connect(self.modButton, QtCore.SIGNAL('clicked()'), self.modDialog)
        self.connect(self.infoButton, QtCore.SIGNAL('clicked()'), self.fitInformation)

    def updateTable(self, current=None):
	    self.table.clear()
	    self.table.setRowCount(0)
	    self.table.setColumnCount(5)
	    self.table.setHorizontalHeaderLabels(["Ref", "Var", "Guess","Min","Max"])
	    self.table.setAlternatingRowColors(True)
	    self.table.setEditTriggers(QtGui.QTableWidget.NoEditTriggers)
	    self.table.setSelectionBehavior(QtGui.QTableWidget.SelectRows)
	    self.table.setSelectionMode(QtGui.QTableWidget.SingleSelection)
	    
    def delRow(self):
        n = atoi(str(self.table.currentRow()))
        self.table.removeRow(n)

    def addDialog(self):
        self.dialog = varinpdialog.GuessInput()
        self.dialog.show()
        self.dialog.refCombo.addItems(self.mini)
        if self.dialog.exec_():
            tempvar = [str(self.dialog.refCombo.currentText()),str(self.dialog.variable.text()),str(self.dialog.guess.text()),str(self.dialog.min.text()),str(self.dialog.max.text())]
            self.table.insertRow(self.table.rowCount())
            for a,item in enumerate(tempvar):
                item0 = QtGui.QTableWidgetItem(str(item))
                self.table.setItem(self.table.rowCount()-1,a, item0)
                
    def modDialog(self):
        if self.table.currentRow() == -1:
            return
        self.dialog = varinpdialog.GuessInput()
        self.dialog.show()
        self.dialog.refCombo.addItems(self.mini)
        a = self.dialog.refCombo.findText(str( self.table.item(self.table.currentRow(),0).text()))
        self.dialog.refCombo.setCurrentIndex(a)
        self.dialog.variable.setText(str( self.table.item(self.table.currentRow(),1).text()))
        self.dialog.guess.setText(str( self.table.item(self.table.currentRow(),2).text()))
        self.dialog.min.setText(str( self.table.item(self.table.currentRow(),3).text()))
        self.dialog.max.setText(str( self.table.item(self.table.currentRow(),4).text()))
        if self.dialog.exec_():
            tempvar = [str(self.dialog.refCombo.currentText()),str(self.dialog.variable.text()),str(self.dialog.guess.text()),str(self.dialog.min.text()),str(self.dialog.max.text())]
            for a,item in enumerate(tempvar):
                item0 = QtGui.QTableWidgetItem(str(item))
                self.table.setItem(self.table.currentRow(),a, item0)
  
        
    def selectFile(self):
        if not str(self.fileSelect.text()) == '':
            self.home = str(self.fileSelect.text())
        fileName = QtGui.QFileDialog.getOpenFileName(self,'select file', self.home,  'Ascii files ( *.txt *.dat ) ;;All files ( *.* )')
        if len(fileName) == 0:
            return
        fileName=str(fileName)
        self.home = str(fileName)
        self.fileSelect.setText(fileName)
        
    def saveFile(self):
        if not str(self.outSelect.text()) == '':
            self.home = str(self.outSelect.text())
        out = QtGui.QFileDialog.getSaveFileName(self,'select file', self.home,  'Ascii files ( *.txt *.dat ) ;;All files ( *.* )')
        if len(out) == 0:
            return
        out = str(out)
        self.home = str(out)
        self.outSelect.setText(out)
        
    def fitInformation(self):
        QtGui.QMessageBox.information(self,
                                "Fit Tags Information",
                                ''' Fit option tags referred to 'scan':
       "angleshift"
       "norm" = R*norm
       "noise" = R + noise
  Fit option tags referred to the layers:
       "roughness" in A
       "tickness" in A
       "density" in g/cm3
      ''')

if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    qb = Minref()
    qb.show()
    sys.exit(app.exec_())
